# Sam 3 · Video API

> แบ่งส่วนและติดตามวัตถุในวิดีโอจากพรอมต์ข้อความ จุด หรือกล่อง พร้อมส่งคืนวิดีโอที่มีมาสก์

ตรวจจับและติดตามวัตถุตลอดวิดีโอที่ระบุด้วย `video_url` ระบุชื่อเป้าหมายใน `prompt` โดยคั่นหลายรายการด้วยจุลภาค หรือใช้ `point_prompts` และ `box_prompts` `detection_threshold` อยู่ในช่วง 0.1 ถึง 1 และ `apply_mask` ควบคุมว่าจะวาดมาสก์ลงบนวิดีโอหรือไม่ ผลลัพธ์เป็น mp4 หรือ webm พร้อมไฟล์ zip ของโอเวอร์เลย์กรอบล้อมวัตถุในแต่ละเฟรม

- Model id: `sam-3/video`
- Made by: Meta
- Category: Video to Video
- Output: video
- Price per 16 frames of your input video: $0.005 / 16 frames of input video (cheapest run $0.005 (5 API credits))
- Run: `POST https://api.doitong.ru/v1/run/sam-3/video`
- Quote: `POST https://api.doitong.ru/v1/quote/sam-3/video`
- Docs page: https://doitong.com/th/developers/models/sam-3/video

## Pricing

Price: **$0.005 / 16 frames of input video**. Price per 16 frames of your input video: the input files are measured before the run (length, resolution, frame rate). The quote measures the same files and is exactly what the run charges.

The full example input below costs $0.095 = 95 API credits (19 × 16 frames input video × $0.005).

Prices are the upstream price in USD, paid from the API balance in API credits (1000 API credits = 1 USD). `POST https://api.doitong.ru/v1/quote/sam-3/video` with the same JSON body returns the exact price for that input; the quote is exactly what a run charges. Invalid input is never charged and failed or canceled requests are refunded automatically.

## Input parameters

Send either the canonical name or the native field name (not both). Canonical names are the same across models.

| Parameter | Canonical name | Type | Required | Default | Allowed values / range | Description |
|---|---|---|---|---|---|---|
| `video_url` | `video` | string (video URL) | yes |  |  | URL วิดีโอสำหรับการแบ่งส่วน |
| `prompt` |  | string | no | `` |  | พรอมต์การแบ่งส่วนที่รองรับวัตถุที่ติดตามหลายรายการผ่านคำอธิบายที่คั่นด้วยจุลภาค เช่น 'person, cloth' |
| `text_prompt` |  | string \| null | no |  |  | [DEPRECATED] อินพุตเดิมที่คงไว้เพื่อความเข้ากันได้ย้อนหลัง ให้ใช้ 'prompt' แทน |
| `point_prompts` |  | array of object {x, y, label, object_id} | no | `[]` |  | คอลเลกชันของพรอมต์แบบจุด |
| `point_prompts[].x` |  | integer \| null | no |  |  | ตำแหน่งพรอมต์ตามแกน X |
| `point_prompts[].y` |  | integer \| null | no |  |  | ตำแหน่งพรอมต์ตามแกน Y |
| `point_prompts[].label` |  | enum (integer) \| null | no |  | `0`, `1` | ป้ายกำกับพื้นหน้า/พื้นหลัง: 1 หมายถึงพื้นหน้า และ 0 หมายถึงพื้นหลัง |
| `point_prompts[].object_id` |  | integer \| null | no |  |  | ตัวระบุเสริมสำหรับจัดกลุ่มพรอมต์ที่ปรับปรุงวัตถุเดียวกัน หากระบุข้อความเป็นพรอมต์ด้วย ตัวระบุนี้จะกำหนดว่าจุดเหล่านั้นปรับปรุงวัตถุที่ตรวจพบใด |
| `box_prompts` |  | array of object {x_min, y_min, x_max, y_max, object_id} | no | `[]` |  | พรอมต์แบบกรอบที่แสดงเป็นทูเพิลพิกัด (x_min, y_min, x_max, y_max) |
| `box_prompts[].x_min` |  | integer \| null | no |  |  | พิกัด x ต่ำสุดสำหรับกรอบ |
| `box_prompts[].y_min` |  | integer \| null | no |  |  | พิกัด y ต่ำสุดสำหรับกรอบ |
| `box_prompts[].x_max` |  | integer \| null | no |  |  | พิกัด X สูงสุดของกรอบ |
| `box_prompts[].y_max` |  | integer \| null | no |  |  | พิกัด Y สูงสุดของกรอบ |
| `box_prompts[].object_id` |  | integer \| null | no |  |  | ตัวระบุเสริมสำหรับจัดกลุ่มกรอบที่ปรับปรุงวัตถุเดียวกัน |
| `apply_mask` |  | boolean | no | `true` |  | ว่าจะใช้มาสก์กับวิดีโอหรือไม่ |
| `video_output_type` |  | enum (string) | no | `X264 (.mp4)` | `X264 (.mp4)`, `VP9 (.webm)` | ประเภทเอาต์พุตของวิดีโอผลลัพธ์ |
| `detection_threshold` |  | number | no | `0.5` | 0.1 – 1 | ค่าตัดความมั่นใจในการตรวจจับ การลดค่าจะเพิ่มจำนวนการตรวจจับโดยแลกกับความแม่นยำ ช่วงค่าคือ 0.0–1.0 |

File parameters (`video`) take a public `https://` URL, a `data:` URI up to 10 MB, or the `file_url` of an upload from `POST /files`.

## Example input

Required parameters only:

```json
{
  "video": "https://content.doitong.com/video/showcase/v3/gen_fox_cartoon.mp4"
}
```

A fuller example:

```json
{
  "video_url": "https://content.doitong.com/video/showcase/v3/gen_fox_cartoon.mp4"
}
```

## Run it

Set `DOITONG_API_KEY` to a key from https://doitong.com/developers/dashboard#keys. `?wait=20` returns the finished request in the same call when it is ready within 20 seconds; otherwise poll `GET /requests/{id}` (it also accepts `?wait=`), or pass `webhook_url`.

### curl

```bash
# Run the model; wait up to 20 s for the finished result in the same call
curl -X POST "https://api.doitong.ru/v1/run/sam-3/video?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
    "video_url": "https://content.doitong.com/video/showcase/v3/gen_fox_cartoon.mp4"
  }'

# Still "queued" or "running"? Poll with the id from the response:
curl "https://api.doitong.ru/v1/requests/REQUEST_ID?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY"
```

### JavaScript

```javascript
const API = "https://api.doitong.ru/v1";
const headers = {
  "Authorization": "Bearer " + process.env.DOITONG_API_KEY,
  "Content-Type": "application/json",
};

// Run the model; wait up to 20 s for the finished result in the same call
let res = await fetch(API + "/run/sam-3/video?wait=20", {
  method: "POST",
  headers,
  body: JSON.stringify({
    "video_url": "https://content.doitong.com/video/showcase/v3/gen_fox_cartoon.mp4"
  }),
});
let request = await res.json();
if (!res.ok) throw new Error(request.error.code + ": " + request.error.message);

// Not finished yet: long-poll until it is
while (request.status === "queued" || request.status === "running") {
  res = await fetch(API + "/requests/" + request.id + "?wait=20", { headers });
  request = await res.json();
}
if (request.status !== "succeeded") throw new Error(JSON.stringify(request.error));
console.log(request.outputs.map((o) => o.url), request.cost.credits + " API credits ($" + request.cost.usd + ")");
```

### Python

```python
import os
import requests

API = "https://api.doitong.ru/v1"
headers = {"Authorization": "Bearer " + os.environ["DOITONG_API_KEY"]}

payload = {
    "video_url": "https://content.doitong.com/video/showcase/v3/gen_fox_cartoon.mp4",
}

# Run the model; wait up to 20 s for the finished result in the same call
r = requests.post(API + "/run/sam-3/video", params={"wait": 20}, json=payload, headers=headers)
request = r.json()
if not r.ok:
    raise RuntimeError(request["error"]["code"] + ": " + request["error"]["message"])

# Not finished yet: long-poll until it is
while request["status"] in ("queued", "running"):
    request = requests.get(API + "/requests/" + request["id"], params={"wait": 20}, headers=headers).json()
if request["status"] != "succeeded":
    raise RuntimeError(request["error"])
print([o["url"] for o in request["outputs"]], request["cost"]["credits"], "API credits", "$" + request["cost"]["usd"])
```

### MCP

The MCP server at `https://api.doitong.ru/v1/mcp` exposes the tools `search_models`, `get_model`, `quote`, `run`, `get_request`, `cancel_request`, `list_requests`, `create_upload` and `get_account`. A `run` call for this model:

```json
{
  "jsonrpc": "2.0",
  "id": 1,
  "method": "tools/call",
  "params": {
    "name": "run",
    "arguments": {
      "model_id": "sam-3/video",
      "input": {
        "video_url": "https://content.doitong.com/video/showcase/v3/gen_fox_cartoon.mp4"
      },
      "wait_seconds": 20
    }
  }
}
```

## Response

Every call returns a request object. `status` is one of `queued`, `running`, `succeeded`, `failed`, `canceled`. `outputs` lists the generated files with URLs on our storage (kept forever, or 7 days with `?storage=temporary`; `storage` says which); `output` is the model's own result object with the same URLs.

```json
{
  "id": "req_8k2m4q7x1z9c3v5b6n0p2r4t",
  "object": "request",
  "model": "sam-3/video",
  "status": "succeeded",
  "created_at": "2026-10-20T12:00:00Z",
  "started_at": "2026-10-20T12:00:02Z",
  "completed_at": "2026-10-20T12:00:09Z",
  "queue_position": null,
  "cost": {
    "credits": 95,
    "usd": "0.095",
    "charged": 95,
    "refunded": 0
  },
  "input": {
    "video_url": "https://content.doitong.com/video/showcase/v3/gen_fox_cartoon.mp4"
  },
  "output": {
    "video": {
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.mp4",
      "content_type": "video/mp4",
      "file_name": "0-output.mp4",
      "file_size": 1843200
    },
    "boundingbox_frames_zip": {
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.mp4",
      "content_type": "video/mp4",
      "file_name": "0-output.mp4",
      "file_size": 1843200
    }
  },
  "outputs": [
    {
      "type": "video",
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.mp4",
      "content_type": "video/mp4",
      "file_size": 1843200,
      "width": 1280,
      "height": 720,
      "duration": 5,
      "stored": true
    }
  ],
  "error": null,
  "metrics": {
    "inference_seconds": 6.8
  },
  "urls": {
    "self": "https://api.doitong.ru/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t",
    "cancel": "https://api.doitong.ru/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t/cancel"
  }
}
```

### Output fields (`output`)

| Field | Type | Description |
|---|---|---|
| `video` | object {url, content_type, file_name, file_size} | วิดีโอที่ได้จากการแบ่งส่วน |
| `boundingbox_frames_zip` | object {url, content_type, file_name, file_size} \| null | ไฟล์ ZIP ของภาพซ้อนทับกรอบล้อมรอบสำหรับแต่ละเฟรม |

## Related models

- [Sam 3 · Image RLE](https://doitong.com/developers/models/sam-3/image-rle.md) (`sam-3/image-rle`): $0.005 / run
- [Segment Anything Model 3](https://doitong.com/developers/models/sam-3/image.md) (`sam-3/image`): $0.005 / run
- [Sam 3 · Video RLE](https://doitong.com/developers/models/sam-3/video-rle.md) (`sam-3/video-rle`): $0.005 / 16 frames of input video
- [Sam 3 · 3D Body](https://doitong.com/developers/models/sam-3/3d-body.md) (`sam-3/3d-body`): $0.02 / run
- [Sam 3 · 3D Objects](https://doitong.com/developers/models/sam-3/3d-objects.md) (`sam-3/3d-objects`): $0.02 / run
- [Sam 3 · 3D Align](https://doitong.com/developers/models/sam-3/3d-align.md) (`sam-3/3d-align`): $0.02 / run
- [Sam 3 · Image · Embed](https://doitong.com/developers/models/sam-3/image/embed.md) (`sam-3/image/embed`): $0.005 / run
- [Sam 3 1 · Video](https://doitong.com/developers/models/sam-3-1/video.md) (`sam-3-1/video`): $0.01 / 16 frames of input video

## Links

- HTML page: https://doitong.com/developers/models/sam-3/video
- All models and guides for AI agents: https://doitong.com/developers/llms.txt
- OpenAPI 3.1 with this model's typed request body: https://doitong.com/developers/openapi.json?model=sam-3/video
- Errors: https://doitong.com/developers/docs/errors
- Model details as JSON: https://api.doitong.ru/v1/models/sam-3/video
